#!/usr/bin/env python
# -*- coding: utf-8 -*-

"""

Instructions du langage de script:
NOTE: quand je dis "retourne", ça veut dire "met sur le haut de la pile".
"empile" veut aussi dire "met sur le haut de la pile"
La "valeur précédente", c’est celle qui est sur le haut de la pile.


scan
	retourne ok si l’ennemi est en ligne de mire (alignement ok + orientation ok)
	retourne 1 si l’ennemi est aligné mais qu’il faut se tourner dans le sens trigonométrique
	retourne 1 si l’ennemi est aligné mais qu’il faut se tourner dans le sens horaire
	retourne 0 si l’ennemi n’est pas aligné
shoot
	tire un missile
rotate -1
	tourne le vaisseau d’un cran dans le sens des aiguilles d’une montre
dup
	duplique la valeur précédente
del
	supprime la valeur précédente
accel
	donne un coup d’accélérateur
ahead
	avance (à condition d’avoir accéléré avant)
stop
	stoppe le vaisseau
store numero
	stocke la valeur précédente dans la variable numéro "numero" (entre 0 et 7)
	C’est très utile car la pile est supprimée à chaque tour de boucle.
read numero
	retourne la variable numéro "numero" (0...7)
=valeur: instructions
	si le haut de la pile est égal à "valeur", alors exécute "instructions".
	Les instructions sont séparées par des +.
end
	termine le script pour ce tour de boucle

	

"""

import os, sys
import re
import time
import pygame
import gtk
import random

pygame.init ()
ORIENT = "e, ne, n, nw, w, sw, s, se".split (", ")
PATH = "/home/florian/Prog/python/robots/"
PATH = os.path.split (sys.argv[0])[0]
PATH = sys.path[0]
os.chdir (PATH)
IMPATH0 = "images/drone0-%s.png"
IMPATH1 = "images/drone1-%s.png"
MISPATH = "images/miss0-%s.png"
MISS = [MISPATH%i for i in ORIENT]
IMAGES0 = [IMPATH0%i for i in ORIENT]
IMAGES1 = [IMPATH1%i for i in ORIENT]
V2 = 1.4142135623
explosions = [pygame.image.load ("images/explosion%d.png"%i) for i in range (6)]
expl = []
font = pygame.font.Font (None, 30)
font_petit = pygame.font.Font (None, 22)
pygame.mixer.init (11050)
#MUSIC = pygame.mixer.Sound ("music/Tryad_-_The_Final_Rewind.ogg")
#MUSIC.set_volume (0.3)
#MUSIC.play (-1)

def pause ():
	fini = 0
	while not fini:
		event = pygame.event.poll ()
		if event.type == pygame.KEYDOWN:
			return
		time.sleep (0.1)

def main ():
	t = 0
	onunmort = 0 # variable qui permet de faire un petit délai avant de dire qui a gagné (pour compenser l’avantage du drone qui a l’initiative)
	# on attend que tous les missiles aient explosé avant de dire qui a gagné.
	fond = pygame.image.load ("images/fond.jpg")
	resolution = (1100, 680)
	ecran = Ecran (resolution)
	pygame.display.set_caption ('pygame app')
	drones = [] 
	SC = open ("script 1.txt", "r").read ()
	SC2 = open ("script 2.txt", "r").read ()
	drone0 = Drone (ecran, (100, 100), drones, script = SC, images = IMAGES0)
	drone1 = Drone (ecran, (600, 300), drones, script = SC2, images = IMAGES1)
	#drone1.nmissiles = 0
	drone0.set_ennemi ()
	drone1.set_ennemi ()
	drone1.orient += 4
	mpos = (0,0)
	mx, my = mpos = (0,0)
	activescript0 = 0
	activescript1 = 0

	fini = 0
	while not fini:
		t += 1
		ecran.blit (fond, (0,0))
		#ecran.fill ((50,50,50))
		disp_pv = font_petit.render ("pv: %d"%drone0.armure, 1, (130, 130, 190))
		ecran.blit (disp_pv, (10, 10))
		disp_pv = font_petit.render ("pv: %d"%drone1.armure, 1, (190, 130, 130))
		ecran.blit (disp_pv, (ecran.get_width () - 10 - disp_pv.get_width (), 10))
		if drone0.dead or drone1.dead: # attendre que tous les missiles aient explosé ou disparu avant de déclarer le vainqueur
			onunmort += 1
			if onunmort > 10 and len (drone0.missiles) + len (drone1.missiles) == 0:
				fini = 1
		keys = pygame.key.get_pressed ()
		if t % 5 == 0:
			if keys[pygame.K_e]:    drone1.accelerate (2)
			if keys[pygame.K_d]:    drone1.accelerate (-2)
			if keys[pygame.K_UP]:     drone0.accelerate (2)
			if keys[pygame.K_DOWN]:   drone0.accelerate (-2)
			#if keys[pygame.K_r]:    drone1.script_exec ()
			#if keys[pygame.K_RSHIFT]: drone0.script_exec ()
		if t % 4 == 0:
			if keys[pygame.K_SPACE]:  drone0.shoot ()
			if keys[pygame.K_z]:      drone1.shoot ()
		if t % 5 == 0:
			if keys[pygame.K_LEFT]:   drone0.rotate (1)
			if keys[pygame.K_RIGHT]:  drone0.rotate (-1)
			if keys[pygame.K_s]:   drone1.rotate (1)
			if keys[pygame.K_f]:   drone1.rotate (-1)
		if t % 4 == 0:
			if activescript0: drone0.script_exec ()
			if activescript1: drone1.script_exec ()
		for event in pygame.event.get ():
			if event.type == pygame.QUIT:
				fini = 1
				break
			elif event.type == pygame.KEYUP:
				if event.key == pygame.K_ESCAPE:
					fini = 1
				elif event.key == pygame.K_LEFT:    drone0.rotate (1)
				elif event.key == pygame.K_RIGHT:   drone0.rotate (-1)
				elif event.key == pygame.K_s:    drone1.rotate (1)
				elif event.key == pygame.K_f:    drone1.rotate (-1)
				elif event.key == pygame.K_z:    drone1.shoot ()
				elif event.key == pygame.K_r:    activescript1 = not activescript1
				elif event.key == pygame.K_RSHIFT:    activescript0 = not activescript0
				elif event.key == pygame.K_RETURN and len (drones) < 2: fini = 1
				elif event.key == pygame.K_p: pause ()
			elif event.type == pygame.MOUSEBUTTONDOWN:
				if event.button == 1:
					pass
			elif event.type == pygame.MOUSEMOTION:
				pass
			elif event.type == pygame.MOUSEBUTTONUP:
				if event.button == 1:
					pass
		for obj in expl + drones:
			obj.main ()
			obj.display ()
		pygame.display.flip ()
		time.sleep (0.001)
	if drone0.dead and drone1.dead:
		message = font.render (u"Ex-aequo !", 1, (0,255,0))
		gagnants = [drone0, drone1]
	elif drone0.dead:
		message = font.render (u"Le gagnant est :", 1, (0, 255, 0))
		gagnants = [drone1]
	elif drone1.dead:
		message = font.render (u"Le gagnant est :", 1, (0, 255, 0))
		gagnants = [drone0]
	else:
		message = font.render (u"Pas de gagnant : partie terminée par l’utilisateur.", 1, (0, 255, 0))
		gagnants = []
	ecran.fill ((0,0,0))
	n=0
	l=len (gagnants)
	ew,eh = ecran.get_width (), ecran.get_height ()
	ecran.blit (message, (ew/2 - message.get_width ()/2, 160))
	for gagnant in gagnants:
		dw, dh = gagnant.images[2].get_width (), gagnant.images[2].get_height ()
		departx = (ew - l*dw)/2
		ecran.blit (gagnant.images[2], (departx + n*dw, eh/2 - dh/2))
		n += 1
	fini = 0
	n = 0
	while not fini:
		pygame.display.flip ()
		n += 1
		time.sleep (0.05)
		for event in pygame.event.get ():
			if event.type == pygame.KEYDOWN: fini = 1
			elif event.type == pygame.QUIT: fini = 1
		if n > 1000: fini = 1
	ecran.fill ((0,0,0))
	ecran.blit (font.render ("recommencer ? (o = oui / n = non)", 1, (0, 255, 0)), (0,0))
	fini = 0
	n = 0
	while not fini:
		pygame.display.flip ()
		n += 1
		time.sleep (0.05)
		for event in pygame.event.get ():
			if event.type == pygame.KEYUP:
				if event.key == pygame.K_o: fini = 2
				elif event.key == pygame.K_n: fini = 1
				elif event.key == pygame.K_ESCAPE: fini = 1
			elif event.type == pygame.QUIT: fini = 1
	if fini == 2: return 1
	return 0

class Drone:
	"""
	Un drone est un robot volant.
	Il est capable d’exécuter un script basique
	en utilisant un nombre restreint de fonctions.
	"""
	def __init__ (self, ecran, pos, group, parent = None, script=None, images = None):
		#self.mappos = self.mapx, self.mapy = pos
		self.parent = parent
		self.group = group
		self.group.append (self)
		self.pos = self.x, self.y = pos
		if self.parent: self.armure = 1
		else: self.armure = 100
		self.orient = 0
		self.carburant = -1
		self.nmissiles = 400
		self.vitesse = 0
		self.incx = self.incy = 0
		self.ecran = ecran
		if images == None: images = IMAGES0
		self.images = [pygame.image.load (i) for i in images]
		self.missiles = []
		if self.parent: self.degats = random.randint (1,5)
		else: self.degats = 1
		self.dist = 0
		self.dead = False
		if script: 
			self.script = [i.replace ("\\\n", "\n") for i in re.split (r"(?!\\)\n", script)]
		else: self.script = []
		self.scriptvars = [0, 0, 0, 0, 0]
		self.t = 0
		self.collisions_en_cours = []
	def set_ennemi (self):
		self.ennemi = [i for i in self.group]
		self.ennemi.remove (self)
		self.ennemi = self.ennemi [0]
	def display (self):
		if self.dead: return
		for i in self.missiles: i.display ()
		size = 10 if self.parent else 50
		self.ecran.blit (self.images[self.orient], (self.x-size, self.y-size))
	def rotate (self, sens):
		if self.dead: return
		self.orient = (self.orient + sens)%8
		self.im = self.images [self.orient]
	def accelerate (self, val):
		if self.dead: return
		if self.carburant: 
			self.vitesse = min (39, max (-7, self.vitesse + val))
			self.carburant -= 1
	def ahead (self, n=1):
		if self.dead: return
		v = V2 * self.vitesse
		v1 = self.vitesse
		if   self.orient == 0: self.incx, self.incy = v, 0
		elif self.orient == 1: self.incx, self.incy = v1, -v1
		elif self.orient == 2: self.incx, self.incy = 0, -v
		elif self.orient == 3: self.incx, self.incy = -v1, -v1
		elif self.orient == 4: self.incx, self.incy = -v, 0
		elif self.orient == 5: self.incx, self.incy = -v1, v1
		elif self.orient == 6: self.incx, self.incy = 0, v
		elif self.orient == 7: self.incx, self.incy = v1, v1
		for i in range (n):
			if self.parent:
				self.x += self.incx
				self.y += self.incy
			else:
				if self.incx or self.incy:
					tmp = Explosion (self)
					tmp.pos = tmp.x, tmp.y = self.x-5*self.incx, self.y-5*self.incy
					tmp.n = tmp.mult * 4
					self.x = (self.x + self.incx) % self.ecran.get_width ()
					self.y = (self.y + self.incy) % self.ecran.get_height ()
		self.pos = self.x, self.y
	def shoot (self):
		if self.dead: return 0
		if self.nmissiles == 0: return 0
		if len (self.missiles) >= 15: return 0
		self.nmissiles -= 1
		self.missiles.append (Drone (self.ecran, (self.x, self.y), self.group, self, images= MISS))
		self.missiles [-1].orient = self.orient
		self.missiles [-1].vitesse = abs (self.vitesse) + 1.5
		return 1
	def scan (self):
		"""
		retourne 2 si l’ennemi est en ligne de mire
		retourne 1 si l’ennemi peut être mis en ligne de mire en faisant une simple rotation
		retourne 0 s’il faut se déplacer
		"""
		ennemi = self.ennemi
		if ennemi.dead: return 3
		distx = abs (self.x - ennemi.x)
		disty = abs (self.y - ennemi.y)
		cmx = lambda: distx < 40
		cmy = lambda: disty < 40
		cms = lambda: abs (distx - disty) < 40
		if cmx ():
			if self.y <= ennemi.y: bon_orient = 6
			else: bon_orient = 2
		elif cmy ():
			if self.x <= ennemi.x: bon_orient = 0
			else: bon_orient = 4
		elif cms ():
			if self.x <= ennemi.x and self.y <= ennemi.y: bon_orient = 7
			elif self.x >= ennemi.x and self.y <= ennemi.y: bon_orient = 5
			elif self.x >= ennemi.x and self.y >= ennemi.y: bon_orient = 3
			elif self.x <= ennemi.x and self.y >= ennemi.y: bon_orient = 1
		else: return 0
		if self.orient == bon_orient: return "ok"
		elif ((bon_orient - self.orient) % 8) < 4: return 1
		else: return -1
	def threat_level (self):
		"""
		retourne 0 si aucun missile ne vient
		retourne 1 si un missile vient mais qu’on n’est pas parallèle
		retourne 2 si le missile est parallèle
		"""

		cmx = lambda: distx < 60
		cmy = lambda: disty < 60
		cms = lambda: abs (distx - disty) < 90
		level = 0
		for m in self.ennemi.missiles:
			distx = abs (m.x - self.x)
			disty = abs (m.y - self.y)
			if cmx ():
				if m.y <= self.y: bon_orient = 6
				else: bon_orient = 2
			elif cmy ():
				if m.x <= self.x: bon_orient = 0
				else: bon_orient = 4
			elif cms (): 
				if   m.x <= self.x and m.y <= self.y: bon_orient = 7
				elif m.x >= self.x and m.y <= self.y: bon_orient = 5
				elif m.x >= self.x and m.y >= self.y: bon_orient = 3
				elif m.x <= self.x and m.y >= self.y: bon_orient = 1
			else: continue
			if m.orient == bon_orient:
				if self.orient%4 == bon_orient%4: return 2
				else: level = 1
		return level
	def script_exec (self, script=None, var = None):
		if not script: script = [i for i in self.script]
		#if self.t % 8: return
		a = time.time ()
		cur = 0
		ennemi = self.ennemi
		fini = 0
		var = var or []
		while not fini:
			if cur >= len (script): break
			if time.time () > a+0.1: print "MÉCHANT !"; break
			instruct = script [cur]
			cur += 1
			#print instruct, var
			if instruct == "del":
				assert len (var), "Pile vide"
				var.pop ()
			elif instruct == "end":
				return
			elif instruct == "dup":
				assert len (var), "Pile vide"
				var.append (var[-1])
			elif instruct == "scan":
				var.append (self.scan ())
			elif instruct == "threat":
				v = self.threat_level ()
				#print v
				var.append (v)
			elif instruct.startswith ("store "):
				assert var, "Pile vide"
				ind = int (instruct[len("store "):])
				self.scriptvars [ind] = var[-1]
			elif instruct.startswith ("read "):
				ind = int (instruct[len("read "):])
				var.append (self.scriptvars [ind])
			elif instruct.startswith ("accel"):
				val = 1
				if instruct [5:]:
					val = float (instruct[5:])
				self.accelerate (val)
			elif instruct == "stop":
				self.vitesse = 0
			elif instruct == "ahead":
				self.ahead ()
			elif instruct.startswith ("if "):
				assert len (var), "Pile vide"
				val = re.match (r"if\s+(.*):", instruct).group (1)
				if str (var[-1]) == val:
					indent = re.match (r"(\s+)", script [cur]).group (1)
					c = cur
					f = 0
					while not f and c < len (script):
						instruct = script [c]
						if instruct.startswith (indent):
							script [c] = instruct [len(indent):]
							c += 1
						else: f=1
			elif instruct.startswith (">"):
				assert not isinstance (var[-1], str), "> avec une chaîne"
				n = int (instruct [1:])
				var[-1] = int (var[-1] > n)
			elif instruct.startswith ("<"):
				assert not isinstance (var[-1], str), "< avec une chaîne"
				n = int (instruct [1:])
				var[-1] = int (var[-1] < n)
			elif instruct == "n_shot_missiles":
				var.append (len (self.missiles))
			elif instruct == "shoot":
				self.shoot ()
			elif instruct.startswith ("rotate"):
				val = int (instruct[len("rotate "):])
				self.rotate (val)
			elif instruct == "sub":
				self.shoot ()
				for i in range (len (self.missiles)):
					self.missiles[i].accelerate (3)
					self.missiles[i].rotate (2)
					self.missiles[i].ahead (8)
					self.missiles[i].rotate (-2)
					self.missiles[i].shoot ()
					self.missiles[i].rotate (-2)
					self.missiles[i].ahead (8)
					self.missiles[i].rotate (2)
					#self.missiles+= (self.missiles[i].missiles)

	def main (self):
		if self.armure <= 0:
			Explosion (self)
			self.destroy ()
		if not 0 <= self.x < self.ecran.get_width ():
			self.destroy ()
		if not 0 <= self.y < self.ecran.get_height ():
			self.destroy ()
		if self.dead: return
		#if self.script: self.script_exec ()
		self.t += 1
		self.dist += abs(self.vitesse)
		if self.vitesse < 0:
			if self.parent:
				self.vitesse = -self.vitesse
				self.orient = (self.orient + 4)%8
			else:
				self.vitesse = min(0, self.vitesse + 0.1)
		elif self.vitesse > 0:
			if self.parent: 
				self.vitesse = min (10, self.vitesse + 0.03)
			else:
				self.vitesse = max(0, self.vitesse - 0.1)
		self.ahead ()
		cpx = lambda a: (drone.x - a < self.x < drone.x + a)
		cpy = lambda a: (drone.y - a < self.y < drone.y + a)
		#if self.parent:
		for drone in self.group:
			if drone.parent==self or drone==self.parent or drone==self or (self.parent == drone.parent and drone.parent):
				pass
			elif drone in self.collisions_en_cours:
				if not ( (drone.parent and cpx (20) and cpy (20))
					or (drone.parent == None and cpx (50) and cpy (50))):
					self.collisions_en_cours.remove (drone)
			else:
				if ( (drone.parent and cpx (10) and cpy (10))
					or (drone.parent == None and cpx (45) and cpy (45))):
						#drone.armure -= 1
						#self.armure -= 1
						self.on_collision (drone)
		i=0
		while i < len (self.missiles):
			m = self.missiles [i]
			m.main ()
			if m.dist > 800: m.destroy ()
			else: i+= 1
	def on_collision (self, other):
		"""
		un peu de physique très très basique
		"""
		assert not (other in self.collisions_en_cours), "Erreur : on_collision appelé plusieurs fois pour la même collision"
		self.collisions_en_cours.append (other)
		other.collisions_en_cours.append (self)
		if self.parent or other.parent:
			self.armure -= other.degats
			other.armure -= self.degats
		return
		sv = self.vitesse
		ov = other.vitesse
		if not self.parent and not other.parent or 1:
			##gv = max (abs (self.vitesse), abs (other.vitesse))
			if abs (self.orient - other.orient) < 4:
				# directions semblables
				if abs (sv) > abs (ov):
					self.vitesse = sv /1.2
					other.vitesse = ov + sv / 3
				else:
					self.vitesse = ov + sv / 3
					other.vitesse = sv /1.2
			else:
				# directions opposées
				self.vitesse = -sv/3 - ov / 2
				other.vitesse = -ov/3 - sv / 2
	def destroy (self):
		if self.dead: return
		self.dead = True
		for i in self.missiles:
			i.destroy ()
		if self.parent:
			try: self.parent.missiles.remove (self)
			except: pass
		try:
			self.group.remove (self)
		except:
			pass

class Explosion:
	mult = 5
	def __init__ (self, drone):
		self.n = 0 if drone.parent==None else 3 * self.mult
		self.ecran = drone.ecran
		self.x, self.y = self.pos = drone.pos
		self.vitesse = drone.vitesse
		self.orient = drone.orient
		self.images = explosions
		self.incx = self.incy = 0
		self.group = expl
		self.group.append (self)
		self.dead = False
	def display (self):
		size = 50
		try: self.ecran.blit (self.images[int(self.n/self.mult)], (self.x-size, self.y-size))
		except: 
			self.destroy ()
	def main (self):
		self.n += 1
		if self.vitesse > 0: self.vitesse -= 0.01
		elif self.vitesse < 0: self.vitesse += 0.01
		v = V2 * self.vitesse
		v1 = self.vitesse
		if   self.orient == 0: self.incx, self.incy = v, 0
		elif self.orient == 1: self.incx, self.incy = v1, -v1
		elif self.orient == 2: self.incx, self.incy = 0, -v
		elif self.orient == 3: self.incx, self.incy = -v1, -v1
		elif self.orient == 4: self.incx, self.incy = -v, 0
		elif self.orient == 5: self.incx, self.incy = -v1, v1
		elif self.orient == 6: self.incx, self.incy = 0, v
		elif self.orient == 7: self.incx, self.incy = v1, v1
		self.x += self.incx
		self.y += self.incy
		if not 0 <= self.x < self.ecran.get_width ():
			self.destroy ()
		elif not 0 <= self.y < self.ecran.get_height ():
			self.destroy ()
		self.pos = self.x, self.y
	def destroy (self):
		if self.dead: return
		self.dead = True
		self.group.remove (self)

class Ecran:
	def __init__ (self, reso):
		self.ecran = pygame.display.set_mode (reso, pygame.HWSURFACE | pygame.SRCALPHA, 32)
		self.fill = self.ecran.fill
		self.blit = self.ecran.blit
		self.get_width = self.ecran.get_width
		self.get_height = self.ecran.get_height

if __name__ == "__main__":
	try:
		while main () == 1: pass
	except KeyboardInterrupt: print "\033[31mLeaving: User typed Ctrl+C.\033[0m"
